Index: /trunk/include/FlairSensorActuator/Gps.h
===================================================================
--- /trunk/include/FlairSensorActuator/Gps.h	(revision 12)
+++ /trunk/include/FlairSensorActuator/Gps.h	(revision 13)
@@ -17,223 +17,218 @@
 #include <nmea/nmea.h>
 
-namespace flair
-{
-    namespace core
-    {
-        class cvmatrix;
-        class FrameworkManager;
-        class GeoCoordinate;
-        class Vector3D;
-    }
-    namespace gui
-    {
-        class Layout;
-        class DataPlot1D;
-        class Tab;
-        class TabWidget;
-        class PushButton;
-        class Map;
-        class Label;
-    }
+namespace flair {
+namespace core {
+class cvmatrix;
+class FrameworkManager;
+class GeoCoordinate;
+class Vector3D;
 }
-
-namespace flair
-{
-namespace sensor
-{
-    /*! \class Gps
-    *
-    * \brief Base class for GPS
-    */
-    class Gps : public core::IODevice
-    {
-        public:
-            /*!
-            \enum FixQuality_t
-            \brief Fix qualty indicators
-            */
-            enum class FixQuality_t {
-                Invalid=0,/*!< invalid */
-                Gps=1,/*!< Gps */
-                DGps=2,/*!< Differential Gps */
-                Pps=3,/*!< Pps */
-                Rtk=4,/*!< RTK */
-                RtkFloat=5,/*!< RTK float */
-                Estimated=6,/*!< Estimated */
-                Manual=7,/*!< Manual */
-                Simulation=8,/*!< Simulation */
-                };
-
-            /*!
-            \enum NMEAFlags_t
-            \brief NMEA flags
-            */
-            enum NMEAFlags_t {
-                GGA=0x01,/*!< GGA */
-                VTG=0x02,/*!< VTG */
-                GST=0x04,/*!< GST */
-                };
-
-            /*!
-            * \brief Constructor
-            *
-            * Construct a Gps.
-            *
-            * \param parent parent
-            * \param name name
-            * \param NMEAFlags NMEA sentances to enable
-            */
-            Gps(const core::FrameworkManager* parent,std::string name,NMEAFlags_t NMEAFlags);
-
-            /*!
-            * \brief Destructor
-            *
-            */
-            ~Gps();
-
-            /*!
-            * \brief Use default plot
-            *
-            */
-            void UseDefaultPlot(void);
-
-            /*!
-            * \brief East plot
-            *
-            * \return east plot
-            */
-            gui::DataPlot1D* EPlot(void) const;
-
-            /*!
-            * \brief North plot
-            *
-            * \return north plot
-            */
-            gui::DataPlot1D* NPlot(void) const;
-
-            /*!
-            * \brief Up plot
-            *
-            * \return up plot
-            */
-            gui::DataPlot1D* UPlot(void) const;
-
-            /*!
-            * \brief East velocity plot
-            *
-            * \return east velocity plot
-            */
-            gui::DataPlot1D* VEPlot(void) const;
-
-            /*!
-            * \brief North velocity plot
-            *
-            * \return north velocity plot
-            */
-            gui::DataPlot1D* VNPlot(void) const;
-
-            /*!
-            * \brief Main tab
-            *
-            * \return main tab
-            */
-            gui::TabWidget* GetTab(void) const;
-
-            /*!
-            * \brief Setup Layout
-            *
-            * \return setup Layout
-            */
-            gui::Layout* GetLayout(void) const;
-
-            /*!
-            * \brief Plot tab
-            *
-            * \return plot Tab
-            */
-            gui::Tab* GetPlotTab(void) const;
-
-            /*!
-            * \brief Number of used satellites
-            *
-            * \return number of used satellites
-            */
-            uint16_t NbSat(void) const;
-
-            /*!
-            * \brief Fix Quality
-            *
-            * \return fix quality
-            */
-            FixQuality_t FixQuality(void) const;
-
-            /*!
-            * \brief Set reference for ENU coordinates
-            *
-            * The actual position is used as reference to calculate
-            * ENU coordinates.
-            *
-            * \return fix quality
-            */
-            void SetRef(void);
-
-            /*!
-            * \brief Get ENU position
-            *
-            * \param point to store position
-            */
-            void GetENUPosition(core::Vector3D *point);
-
-        protected:
-            /*!
-            * \brief Parse a NMEA frame
-            *
-            * This function must be called by the reimplemented class. \n
-            * When a frame is parsed, GPS datas are filled.
-            *
-            * \param frame NMEA frame
-            * \param frame_size frame size
-            *
-            */
-            void parseFrame(const char *frame, int frame_size);
-
-            NMEAFlags_t NMEAFlags;
-
-        protected:
-            core::GeoCoordinate *position;
-
-        private:
-            /*!
-            * \brief Update using provided datas
-            *
-            * Reimplemented from IODevice.
-            *
-            * \param data data from the parent to process
-            */
-            void UpdateFrom(const core::io_data *data){};
-
-            gui::Tab *main_tab,*sensor_tab;
-            gui::TabWidget* tab;
-            gui::PushButton *button_ref;
-            gui::DataPlot1D* e_plot;
-            gui::DataPlot1D* n_plot;
-            gui::DataPlot1D* u_plot;
-            gui::DataPlot1D* ve_plot;
-            gui::DataPlot1D* vn_plot;
-            gui::Tab* plot_tab;
-            gui::Map *map;
-            gui::Label *nb_sat_label,*fix_label;
-            uint16_t nb_sat;
-            FixQuality_t fix;
-            bool take_ref;
-            nmeaINFO info;
-            nmeaPARSER parser;
-            nmeaGPGGA pack;
-            nmeaPOS pos;
-            double lat_ref,long_ref,alt_ref;
-
-            //matrix
-            core::cvmatrix *output;
-    };
+namespace gui {
+class Layout;
+class DataPlot1D;
+class Tab;
+class TabWidget;
+class PushButton;
+class Map;
+class Label;
+}
+}
+
+namespace flair {
+namespace sensor {
+/*! \class Gps
+*
+* \brief Base class for GPS
+*/
+class Gps : public core::IODevice {
+public:
+  /*!
+  \enum FixQuality_t
+  \brief Fix qualty indicators
+  */
+  enum class FixQuality_t {
+    Invalid = 0,    /*!< invalid */
+    Gps = 1,        /*!< Gps */
+    DGps = 2,       /*!< Differential Gps */
+    Pps = 3,        /*!< Pps */
+    Rtk = 4,        /*!< RTK */
+    RtkFloat = 5,   /*!< RTK float */
+    Estimated = 6,  /*!< Estimated */
+    Manual = 7,     /*!< Manual */
+    Simulation = 8, /*!< Simulation */
+  };
+
+  /*!
+  \enum NMEAFlags_t
+  \brief NMEA flags
+  */
+  enum NMEAFlags_t {
+    GGA = 0x01, /*!< GGA */
+    VTG = 0x02, /*!< VTG */
+    GST = 0x04, /*!< GST */
+  };
+
+  /*!
+  * \brief Constructor
+  *
+  * Construct a Gps.
+  *
+  * \param parent parent
+  * \param name name
+  * \param NMEAFlags NMEA sentances to enable
+  */
+  Gps(const core::FrameworkManager *parent, std::string name,
+      NMEAFlags_t NMEAFlags);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~Gps();
+
+  /*!
+  * \brief Use default plot
+  *
+  */
+  void UseDefaultPlot(void);
+
+  /*!
+  * \brief East plot
+  *
+  * \return east plot
+  */
+  gui::DataPlot1D *EPlot(void) const;
+
+  /*!
+  * \brief North plot
+  *
+  * \return north plot
+  */
+  gui::DataPlot1D *NPlot(void) const;
+
+  /*!
+  * \brief Up plot
+  *
+  * \return up plot
+  */
+  gui::DataPlot1D *UPlot(void) const;
+
+  /*!
+  * \brief East velocity plot
+  *
+  * \return east velocity plot
+  */
+  gui::DataPlot1D *VEPlot(void) const;
+
+  /*!
+  * \brief North velocity plot
+  *
+  * \return north velocity plot
+  */
+  gui::DataPlot1D *VNPlot(void) const;
+
+  /*!
+  * \brief Main tab
+  *
+  * \return main tab
+  */
+  gui::TabWidget *GetTab(void) const;
+
+  /*!
+  * \brief Setup Layout
+  *
+  * \return setup Layout
+  */
+  gui::Layout *GetLayout(void) const;
+
+  /*!
+  * \brief Plot tab
+  *
+  * \return plot Tab
+  */
+  gui::Tab *GetPlotTab(void) const;
+
+  /*!
+  * \brief Number of used satellites
+  *
+  * \return number of used satellites
+  */
+  uint16_t NbSat(void) const;
+
+  /*!
+  * \brief Fix Quality
+  *
+  * \return fix quality
+  */
+  FixQuality_t FixQuality(void) const;
+
+  /*!
+  * \brief Set reference for ENU coordinates
+  *
+  * The actual position is used as reference to calculate
+  * ENU coordinates.
+  *
+  * \return fix quality
+  */
+  void SetRef(void);
+
+  /*!
+  * \brief Get ENU position
+  *
+  * \param point to store position
+  */
+  void GetENUPosition(core::Vector3D *point);
+
+protected:
+  /*!
+  * \brief Parse a NMEA frame
+  *
+  * This function must be called by the reimplemented class. \n
+  * When a frame is parsed, GPS datas are filled.
+  *
+  * \param frame NMEA frame
+  * \param frame_size frame size
+  *
+  */
+  void parseFrame(const char *frame, int frame_size);
+
+  NMEAFlags_t NMEAFlags;
+
+protected:
+  core::GeoCoordinate *position;
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
+
+  gui::Tab *main_tab, *sensor_tab;
+  gui::TabWidget *tab;
+  gui::PushButton *button_ref;
+  gui::DataPlot1D *e_plot;
+  gui::DataPlot1D *n_plot;
+  gui::DataPlot1D *u_plot;
+  gui::DataPlot1D *ve_plot;
+  gui::DataPlot1D *vn_plot;
+  gui::Tab *plot_tab;
+  gui::Map *map;
+  gui::Label *nb_sat_label, *fix_label;
+  uint16_t nb_sat;
+  FixQuality_t fix;
+  bool take_ref;
+  nmeaINFO info;
+  nmeaPARSER parser;
+  nmeaGPGGA pack;
+  nmeaPOS pos;
+  double lat_ref, long_ref, alt_ref;
+
+  // matrix
+  core::cvmatrix *output;
+};
 } // end namespace sensor
 } // end namespace framewor
Index: /trunk/include/FlairSensorActuator/Gx3_25_imu.h
===================================================================
--- /trunk/include/FlairSensorActuator/Gx3_25_imu.h	(revision 12)
+++ /trunk/include/FlairSensorActuator/Gx3_25_imu.h	(revision 13)
@@ -18,69 +18,72 @@
 
 namespace flair {
-    namespace core {
-        class FrameworkManager;
-        class SerialPort;
-    }
+namespace core {
+class FrameworkManager;
+class SerialPort;
+}
 }
 
 class Gx3_25_imu_impl;
 
-namespace flair { namespace sensor {
-    /*! \class Gx3_25_imu
-    *
-    * \brief Class for 3dmgx3-25 Imu
-    */
-    class Gx3_25_imu : public Imu, public core::Thread {
-        friend class ::Gx3_25_imu_impl;
+namespace flair {
+namespace sensor {
+/*! \class Gx3_25_imu
+*
+* \brief Class for 3dmgx3-25 Imu
+*/
+class Gx3_25_imu : public Imu, public core::Thread {
+  friend class ::Gx3_25_imu_impl;
 
-        public:
-            /*!
-            \enum Command_t
-            \brief Command for the continuous mode
-            */
-            enum Command_t{
-                EulerAnglesAndAngularRates=0xcf,/*!< Euler angles and angular rates */
-                AccelerationAngularRateAndOrientationMatrix=0xc8,/*!< Acceleration, angular rate and orientation matrix */
-                };
+public:
+  /*!
+  \enum Command_t
+  \brief Command for the continuous mode
+  */
+  enum Command_t {
+    EulerAnglesAndAngularRates = 0xcf, /*!< Euler angles and angular rates */
+    AccelerationAngularRateAndOrientationMatrix =
+        0xc8, /*!< Acceleration, angular rate and orientation matrix */
+  };
 
-            /*!
-            * \brief Constructor
-            *
-            * Construct a Gx3_25_imu.
-            *
-            * \param parent parent
-            * \param name name
-            * \param serialport SerialPort
-            * \param command command for continuous mode
-            * \param priority priority of the Thread
-            */
-            Gx3_25_imu(const core::FrameworkManager* parent,std::string name,core::SerialPort *serialport,Command_t command,uint8_t priority);
+  /*!
+  * \brief Constructor
+  *
+  * Construct a Gx3_25_imu.
+  *
+  * \param parent parent
+  * \param name name
+  * \param serialport SerialPort
+  * \param command command for continuous mode
+  * \param priority priority of the Thread
+  */
+  Gx3_25_imu(const core::FrameworkManager *parent, std::string name,
+             core::SerialPort *serialport, Command_t command, uint8_t priority);
 
-            /*!
-            * \brief Destructor
-            *
-            */
-            ~Gx3_25_imu();
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~Gx3_25_imu();
 
-        private:
-            /*!
-            * \brief Run function
-            *
-            * Reimplemented from Thread.
-            *
-            */
-            void Run(void);
+private:
+  /*!
+  * \brief Run function
+  *
+  * Reimplemented from Thread.
+  *
+  */
+  void Run(void);
 
-            /*!
-            * \brief Update using provided datas
-            *
-            * Reimplemented from IODevice.
-            *
-            * \param data data from the parent to process
-            */
-            void UpdateFrom(const core::io_data *data){};
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
 
-            class Gx3_25_imu_impl* pimpl_;
-    };
+  class Gx3_25_imu_impl *pimpl_;
+};
 } // end namespace sensor
 } // end namespace flair
Index: /trunk/include/FlairSensorActuator/HokuyoUTM30Lx.h
===================================================================
--- /trunk/include/FlairSensorActuator/HokuyoUTM30Lx.h	(revision 12)
+++ /trunk/include/FlairSensorActuator/HokuyoUTM30Lx.h	(revision 13)
@@ -21,154 +21,150 @@
 #include <vector>
 
-namespace flair
-{
-    namespace core
-    {
-        class cvmatrix;
-        class FrameworkManager;
-        class SerialPort;
-        class Mutex;
-    }
-    namespace gui
-    {
-        class Tab;
-        class TabWidget;
-        class RangeFinderPlot;
-    }
+namespace flair {
+namespace core {
+class cvmatrix;
+class FrameworkManager;
+class SerialPort;
+class Mutex;
+}
+namespace gui {
+class Tab;
+class TabWidget;
+class RangeFinderPlot;
+}
 }
 
-namespace flair
-{
-namespace sensor
-{
-    /*! \class HokuyoUTM30Lx
-    *
-    * \brief Classe intégrant le telemetre laser Hokuyo UTM 30lx
-    */
-    class HokuyoUTM30Lx : public core::Thread, public LaserRangeFinder
-    {
-        public:
+namespace flair {
+namespace sensor {
+/*! \class HokuyoUTM30Lx
+*
+* \brief Classe intégrant le telemetre laser Hokuyo UTM 30lx
+*/
+class HokuyoUTM30Lx : public core::Thread, public LaserRangeFinder {
+public:
+  /*!
+ * \brief Constructor
+ *
+ * Construct a Hokuyo UTM30-Lx.
+ *
+ * \param parent parent
+ * \param name name
+ * \param serialport serialport
+ * \param priority priority of the Thread
+ */
+  HokuyoUTM30Lx(const core::FrameworkManager *parent, std::string name,
+                core::SerialPort *serialport, uint8_t priority);
+  void getMesure(int startStep, int endStep, int clusterCount, int interval,
+                 int scanNumber = 0);
+  core::cvmatrix *getDatas(void);
 
-             /*!
-            * \brief Constructor
-            *
-            * Construct a Hokuyo UTM30-Lx.
-            *
-            * \param parent parent
-            * \param name name
-            * \param serialport serialport
-            * \param priority priority of the Thread
-            */
-            HokuyoUTM30Lx(const core::FrameworkManager* parent,std::string name,core::SerialPort *serialport,uint8_t priority);
-            void getMesure(int startStep, int endStep,int clusterCount, int interval, int scanNumber=0);
-            core::cvmatrix* getDatas(void);
+  /*!
+  * \brief Use default plot
+  *
+  */
+  void UseDefaultPlot(void);
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~HokuyoUTM30Lx();
 
-            /*!
-            * \brief Use default plot
-            *
-            */
-            void UseDefaultPlot(void);
-            /*!
-            * \brief Destructor
-            *
-            */
-            ~HokuyoUTM30Lx();
+private:
+  core::SerialPort *serialport;
+  core::Mutex *bufRetMut;
+  core::Mutex *sendingCmdMut;
+  gui::Tab *main_tab;
+  gui::TabWidget *tab;
+  gui::RangeFinderPlot *plot;
 
-        private:
-            core::SerialPort *serialport;
-            core::Mutex* bufRetMut;
-            core::Mutex* sendingCmdMut;
-            gui::Tab* main_tab;
-            gui::TabWidget* tab;
-            gui::RangeFinderPlot* plot;
+  // matrix
+  core::cvmatrix *output;
 
-            //matrix
-            core::cvmatrix *output;
+  std::queue<std::string> bufRet;
 
-			std::queue<std::string> bufRet;
+  /*!
+  * \brief Run function
+  *
+  * Reimplemented from Thread.
+  *
+  */
+  void Run(void);
+  /*!
+  * \brief Send a command
+  * \param command Command to send (see Hokuyo UTM 30-LX doc for more
+  * informations)
+  * \return Return code
+  */
+  std::string sendCommand(std::string command);
+  /*!
+  * \brief Start the laser
+  *
+  */
+  void startLaser(void);
+  /*!
+  * \brief Stop the laser
+  *
+  */
+  void stopLaser(void);
+  /*!
+* \brief Stop and reset the laser's settings
+*
+*/
+  void resetConfig(void);
+  /*!
+* \brief Decode incomming datas
+* \param datas Datas to decode
+* \param startStep Set the first mesured point
+* Decode mesured points from incoming datas and fill the output matrix
+*/
+  void decodeDatas(std::vector<std::string> datas, int startStep);
+  /*!
+  * \brief Explode a string into a vector
+  * \param str The string to explode
+  * \param delimiter The character separating elements
+  * \return A vector containing the elements
+  */
+  static std::vector<std::string> explode(const std::string str,
+                                          char delimiter);
+  /*!
+* \brief Calculate the checksum
+* \param code Data from which calculate
+* \param byte Data's size
+* \return A character corresponding to the code's checksum
+*/
+  static int encodeSum(const char *code, int byte);
+  /*!
+* \brief Check if a data correspond to its checksum
+* \param data Datas to check
+*/
+  static bool checkSum(std::string data);
+  /*!
+* \brief Decode datas using the 2 character encoding
+* \param data Datas to decode
+* \return Decoded datas
+*/
+  static float decode2car(const char *data);
+  /*!
+* \brief Decode datas using the 3 character encoding
+* \param data Datas to decode
+* \return Decoded datas
+*/
+  static float decode3car(const char *data);
+  /*!
+* \brief Decode datas using the 4 character encoding
+* \param data Datas to decode
+* \return Decoded datas
+*/
+  static float decode4car(const char *data);
 
-            /*!
-            * \brief Run function
-            *
-            * Reimplemented from Thread.
-            *
-            */
-            void Run(void);
-            /*!
-            * \brief Send a command
-            * \param command Command to send (see Hokuyo UTM 30-LX doc for more informations)
-            * \return Return code
-            */
-            std::string sendCommand(std::string command);
-            /*!
-            * \brief Start the laser
-            *
-            */
-            void startLaser(void);
-            /*!
-            * \brief Stop the laser
-            *
-            */
-			void stopLaser(void);
-			/*!
-            * \brief Stop and reset the laser's settings
-            *
-            */
-		    void resetConfig(void);
-		    /*!
-            * \brief Decode incomming datas
-            * \param datas Datas to decode
-            * \param startStep Set the first mesured point
-            * Decode mesured points from incoming datas and fill the output matrix
-            */
-		    void decodeDatas(std::vector<std::string> datas, int startStep);
-            /*!
-            * \brief Explode a string into a vector
-            * \param str The string to explode
-            * \param delimiter The character separating elements
-            * \return A vector containing the elements
-            */
-			static std::vector<std::string> explode(const std::string str, char delimiter);
-			/*!
-            * \brief Calculate the checksum
-            * \param code Data from which calculate
-            * \param byte Data's size
-            * \return A character corresponding to the code's checksum
-            */
-			static int encodeSum(const char* code, int byte);
-			/*!
-            * \brief Check if a data correspond to its checksum
-            * \param data Datas to check
-            */
-			static bool checkSum(std::string data);
-			/*!
-            * \brief Decode datas using the 2 character encoding
-            * \param data Datas to decode
-            * \return Decoded datas
-            */
-			static float decode2car(const char* data);
-			/*!
-            * \brief Decode datas using the 3 character encoding
-            * \param data Datas to decode
-            * \return Decoded datas
-            */
-			static float decode3car(const char* data);
-			/*!
-            * \brief Decode datas using the 4 character encoding
-            * \param data Datas to decode
-            * \return Decoded datas
-            */
-			static float decode4car(const char* data);
-
-			/*!
-            * \brief Update using provided datas
-            *
-            * Reimplemented from IODevice.
-            *
-            * \param data data from the parent to process
-            */
-            void UpdateFrom(const core::io_data *data){};
-
-    };
+  /*!
+* \brief Update using provided datas
+*
+* Reimplemented from IODevice.
+*
+* \param data data from the parent to process
+*/
+  void UpdateFrom(const core::io_data *data){};
+};
 } // end namespace sensor
 } // end namespace framewor
Index: /trunk/include/FlairSensorActuator/HostEthController.h
===================================================================
--- /trunk/include/FlairSensorActuator/HostEthController.h	(revision 12)
+++ /trunk/include/FlairSensorActuator/HostEthController.h	(revision 13)
@@ -11,5 +11,6 @@
 //  version:    $Id: $
 //
-//  purpose:    Base class for host side remote controls that talks to target side through ethernet connection
+//  purpose:    Base class for host side remote controls that talks to target
+//  side through ethernet connection
 //
 //
@@ -24,85 +25,97 @@
 
 namespace flair {
-    namespace core {
-        class FrameworkManager;
-        class cvmatrix;
-        class TcpSocket;
-        class Socket;
-        class Mutex;
-    }
-    namespace gui {
-        class Tab;
-        class TabWidget;
-        class DataPlot1D;
-    }
+namespace core {
+class FrameworkManager;
+class cvmatrix;
+class TcpSocket;
+class Socket;
+class Mutex;
+}
+namespace gui {
+class Tab;
+class TabWidget;
+class DataPlot1D;
+}
 }
 
-namespace flair { namespace sensor {
-    enum class ControllerAction;
+namespace flair {
+namespace sensor {
+enum class ControllerAction;
 
-    /*! \class HostEthController
-    *
-    * \brief Base Class for host side remote controls that talks to target side through ethernet connection
-    *
-    * There are 2 communication channels:
-    *   - 1 connection with the ground station to display the values. Output for analog sticks is normalized in the range [-1, 1] (float values)
-    *   - 1 connection with the target to send the controller values (and receive controller state modification requests)
-    */
-    class HostEthController : public core::Thread, public core::IODevice {
-    public:
-        HostEthController(const core::FrameworkManager* parent,std::string name,std::string address,int port,uint32_t period=10,uint32_t _bitsPerAxis=7,uint8_t priority=0);
-        ~HostEthController();
-        void DrawUserInterface();
-    protected:
-        std::string controllerName;
-        core::TcpSocket *controlSocket; //connection to the target
-        core::Socket *dataSocket;
-        std::string targetAddress;
-        int targetPort;
-        gui::Tab *tab;
-        gui::TabWidget *tabWidget;
-        virtual bool IsDataFrameReady() { return true;};
-        virtual void CompleteDataFrameGrab() {};
-//        int8_t *datas;
-//        uint8_t dataSize;
-        char *dataFrameBuffer;
-        size_t dataFrameSize;
-        virtual void ProcessMessage(core::Message *controllerAction) {};
+/*! \class HostEthController
+*
+* \brief Base Class for host side remote controls that talks to target side
+*through ethernet connection
+*
+* There are 2 communication channels:
+*   - 1 connection with the ground station to display the values. Output for
+*analog sticks is normalized in the range [-1, 1] (float values)
+*   - 1 connection with the target to send the controller values (and receive
+*controller state modification requests)
+*/
+class HostEthController : public core::Thread, public core::IODevice {
+public:
+  HostEthController(const core::FrameworkManager *parent, std::string name,
+                    std::string address, int port, uint32_t period = 10,
+                    uint32_t _bitsPerAxis = 7, uint8_t priority = 0);
+  ~HostEthController();
+  void DrawUserInterface();
 
-        virtual std::string GetAxisDescription(unsigned int axis);
-        virtual void GetAxisData()=0; //responsible for getting the axis data from the hardware
-        unsigned int axisNumber;
-        core::cvmatrix* axis;
-        gui::DataPlot1D **axisPlot;
-        uint32_t bitsPerAxis;
-        uint32_t nativeBitsPerAxis;
+protected:
+  std::string controllerName;
+  core::TcpSocket *controlSocket; // connection to the target
+  core::Socket *dataSocket;
+  std::string targetAddress;
+  int targetPort;
+  gui::Tab *tab;
+  gui::TabWidget *tabWidget;
+  virtual bool IsDataFrameReady() { return true; };
+  virtual void CompleteDataFrameGrab(){};
+  //        int8_t *datas;
+  //        uint8_t dataSize;
+  char *dataFrameBuffer;
+  size_t dataFrameSize;
+  virtual void ProcessMessage(core::Message *controllerAction){};
 
-        virtual std::string GetButtonDescription(unsigned int button);
-        virtual void GetButtonData()=0; //responsible for getting the button data from the hardware
-        unsigned int buttonNumber;
-        core::cvmatrix* button;
-        uint8_t buttonOffset;
-        bool meaningfulDataAvailable;
+  virtual std::string GetAxisDescription(unsigned int axis);
+  virtual void
+  GetAxisData() = 0; // responsible for getting the axis data from the hardware
+  unsigned int axisNumber;
+  core::cvmatrix *axis;
+  gui::DataPlot1D **axisPlot;
+  uint32_t bitsPerAxis;
+  uint32_t nativeBitsPerAxis;
 
-    private:
-        class DataSender : public core::Thread {
-        public:
-            DataSender(Object* parent,HostEthController* hostEthController,std::string name,uint8_t priority=0);
-            void Run();
-        private:
-            HostEthController* hostEthController;
-        };
-        DataSender *dataSender;
+  virtual std::string GetButtonDescription(unsigned int button);
+  virtual void GetButtonData() = 0; // responsible for getting the button data
+                                    // from the hardware
+  unsigned int buttonNumber;
+  core::cvmatrix *button;
+  uint8_t buttonOffset;
+  bool meaningfulDataAvailable;
 
-        bool ControllerInitialization();
-        bool ConnectedWithTarget();
-        void SendControllerInfo();
-        void Run();
-        void BuildDataFrame();
-        bool writeBits(uint16_t value,uint8_t valueSizeInBits,char *buffer,uint8_t offsetInBits);
-        core::Mutex *connectionEstablishedMutex;
-    };
+private:
+  class DataSender : public core::Thread {
+  public:
+    DataSender(Object *parent, HostEthController *hostEthController,
+               std::string name, uint8_t priority = 0);
+    void Run();
 
-}}
+  private:
+    HostEthController *hostEthController;
+  };
+  DataSender *dataSender;
+
+  bool ControllerInitialization();
+  bool ConnectedWithTarget();
+  void SendControllerInfo();
+  void Run();
+  void BuildDataFrame();
+  bool writeBits(uint16_t value, uint8_t valueSizeInBits, char *buffer,
+                 uint8_t offsetInBits);
+  core::Mutex *connectionEstablishedMutex;
+};
+}
+}
 
 #endif // HOSTETHCONTROLLER_H
